/*
Copyright (c) 2011, Senio Networks, Inc.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

#ifndef SOFT_SPI_H
#define SOFT_SPI_H

#include "mbed.h"

class SoftSPI {
public:
    SoftSPI(PinName mosi, PinName miso, PinName sclk)
            : mosi(mosi), miso(miso), sclk(sclk), bits(8), mode(0) {
    }

    int write(int value) {
        int value1 = 0;
        for (int bit = 128; bit != 0; bit >>= 1) {
            sclk = 0;
            mosi = value & bit;
            sclk = 1;
            if (miso) value1 |= bit;
        }
        return value1;
    }

    void format(int bits, int mode = 0) {
        this->bits = bits;
        this->mode = mode;
    }

    void frequency(int hz) {
    }

private:
    DigitalOut mosi;
    DigitalIn miso;
    DigitalOut sclk;
    int bits;
    int mode;
};

#endif